"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.reducer = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _isEqual = _interopRequireDefault(require("lodash/isEqual"));

var _useFormApi = _interopRequireDefault(require("../use-form-api"));

var _parseCondition = _interopRequireDefault(require("../parse-condition"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var reducer = function reducer(state, _ref) {
  var type = _ref.type,
      sets = _ref.sets;

  switch (type) {
    case 'formResetted':
      return _objectSpread(_objectSpread({}, state), {}, {
        initial: true
      });

    case 'rememberSets':
      return _objectSpread(_objectSpread({}, state), {}, {
        initial: false,
        sets: sets
      });

    default:
      return state;
  }
};

exports.reducer = reducer;

var Condition = _react["default"].memo(function (_ref2) {
  var condition = _ref2.condition,
      children = _ref2.children,
      values = _ref2.values,
      field = _ref2.field;
  var formOptions = (0, _useFormApi["default"])();
  var dirty = formOptions.getState().dirty;

  var _useReducer = (0, _react.useReducer)(reducer, {
    sets: [],
    initial: true
  }),
      _useReducer2 = (0, _slicedToArray2["default"])(_useReducer, 2),
      state = _useReducer2[0],
      dispatch = _useReducer2[1];

  var conditionResult = (0, _parseCondition["default"])(condition, values, field);
  var setters = conditionResult.set ? [conditionResult.set] : conditionResult.sets;
  (0, _react.useEffect)(function () {
    if (!dirty) {
      dispatch({
        type: 'formResetted'
      });
    }
  }, [dirty]);
  (0, _react.useEffect)(function () {
    if (setters && setters.length > 0 && (state.initial || !(0, _isEqual["default"])(setters, state.sets))) {
      setters.forEach(function (setter, index) {
        if (setter && (state.initial || !(0, _isEqual["default"])(setter, state.sets[index]))) {
          setTimeout(function () {
            formOptions.batch(function () {
              Object.entries(setter).forEach(function (_ref3) {
                var _ref4 = (0, _slicedToArray2["default"])(_ref3, 2),
                    name = _ref4[0],
                    value = _ref4[1];

                formOptions.change(name, value);
              });
            });
          });
        }
      });
      dispatch({
        type: 'rememberSets',
        sets: setters
      });
    }
  }, [setters, state.initial]);
  return conditionResult.visible ? children : null;
}, function (a, b) {
  return (0, _isEqual["default"])(a.values, b.values) && (0, _isEqual["default"])(a.condition, b.condition);
});

var conditionProps = {
  when: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].arrayOf(_propTypes["default"].string), _propTypes["default"].func]),
  is: _propTypes["default"].oneOfType([_propTypes["default"].array, _propTypes["default"].string, _propTypes["default"].object, _propTypes["default"].number, _propTypes["default"].bool]),
  isNotEmpty: _propTypes["default"].bool,
  isEmpty: _propTypes["default"].bool,
  pattern: function pattern(props, name, componentName) {
    if (!props[name]) {
      return;
    }

    if (typeof props[name] === 'string') {
      return;
    }

    if (props[name] instanceof RegExp) {
      return;
    }

    return new Error("Invalid prop pattern supplied to condition in `".concat(componentName, "`. Validation failed.\n    pattern has to be RegExp or string. Received `").concat((0, _typeof2["default"])(props[name]), "`."));
  },
  notMatch: _propTypes["default"].any,
  then: _propTypes["default"].shape({
    visible: _propTypes["default"].bool,
    set: _propTypes["default"].object
  }),
  "else": _propTypes["default"].shape({
    visible: _propTypes["default"].bool,
    set: _propTypes["default"].object
  })
};
var nestedConditions = {
  or: _propTypes["default"].oneOfType([_propTypes["default"].shape(conditionProps), _propTypes["default"].arrayOf(_propTypes["default"].shape(conditionProps))]),
  and: _propTypes["default"].oneOfType([_propTypes["default"].shape(conditionProps), _propTypes["default"].arrayOf(_propTypes["default"].shape(conditionProps))]),
  not: _propTypes["default"].oneOfType([_propTypes["default"].shape(conditionProps), _propTypes["default"].arrayOf(_propTypes["default"].shape(conditionProps))]),
  sequence: _propTypes["default"].arrayOf(_propTypes["default"].shape(conditionProps))
};

var conditionsProps = _objectSpread(_objectSpread({}, conditionProps), nestedConditions);

Condition.propTypes = {
  condition: _propTypes["default"].oneOfType([_propTypes["default"].shape(conditionsProps), _propTypes["default"].arrayOf(_propTypes["default"].shape(conditionsProps))]),
  children: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].arrayOf(_propTypes["default"].node)]).isRequired,
  values: _propTypes["default"].object.isRequired,
  field: _propTypes["default"].object.isRequired
};
var _default = Condition;
exports["default"] = _default;