"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _toArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toArray"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _rendererContext = _interopRequireDefault(require("../renderer-context"));

var _condition = _interopRequireDefault(require("../condition"));

var _formSpy = _interopRequireDefault(require("../form-spy"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var FormFieldHideWrapper = function FormFieldHideWrapper(_ref) {
  var hideField = _ref.hideField,
      children = _ref.children;
  return hideField ? /*#__PURE__*/_react["default"].createElement("div", {
    hidden: true
  }, children) : children;
};

FormFieldHideWrapper.propTypes = {
  hideField: _propTypes["default"].bool,
  children: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].arrayOf(_propTypes["default"].node)]).isRequired
};
FormFieldHideWrapper.defaultProps = {
  hideField: false
};

var FormConditionWrapper = function FormConditionWrapper(_ref2) {
  var condition = _ref2.condition,
      children = _ref2.children,
      field = _ref2.field;
  return condition ? /*#__PURE__*/_react["default"].createElement(_formSpy["default"], {
    subscription: {
      values: true
    }
  }, function (_ref3) {
    var values = _ref3.values;
    return /*#__PURE__*/_react["default"].createElement(_condition["default"], {
      condition: condition,
      values: values,
      field: field
    }, children);
  }) : children;
};

FormConditionWrapper.propTypes = {
  condition: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].array]),
  children: _propTypes["default"].node.isRequired,
  field: _propTypes["default"].object
};

var SingleField = function SingleField(_ref4) {
  var component = _ref4.component,
      condition = _ref4.condition,
      hideField = _ref4.hideField,
      rest = (0, _objectWithoutProperties2["default"])(_ref4, ["component", "condition", "hideField"]);

  var _useContext = (0, _react.useContext)(_rendererContext["default"]),
      actionMapper = _useContext.actionMapper,
      componentMapper = _useContext.componentMapper;

  var componentProps = _objectSpread({
    component: component
  }, rest);

  var componentBinding = componentMapper[component];
  var Component;

  if ((0, _typeof2["default"])(componentBinding) === 'object' && Object.prototype.hasOwnProperty.call(componentBinding, 'component')) {
    var _component = componentBinding.component,
        mapperProps = (0, _objectWithoutProperties2["default"])(componentBinding, ["component"]);
    Component = _component;
    componentProps = _objectSpread(_objectSpread(_objectSpread(_objectSpread({}, mapperProps), componentProps), mapperProps.actions && rest.actions ? {
      actions: _objectSpread(_objectSpread({}, mapperProps.actions), rest.actions)
    } : {}), mapperProps.resolveProps && rest.resolveProps ? {
      resolveProps: function resolveProps() {
        return _objectSpread(_objectSpread({}, mapperProps.resolveProps.apply(mapperProps, arguments)), rest.resolveProps.apply(rest, arguments));
      }
    } : {});
  } else {
    Component = componentBinding;
  }
  /**
   * Map actions to props
   */


  var overrideProps = {};
  var mergedResolveProps; // new object has to be created because of references

  if (componentProps.actions) {
    Object.keys(componentProps.actions).forEach(function (prop) {
      var _componentProps$actio = (0, _toArray2["default"])(componentProps.actions[prop]),
          action = _componentProps$actio[0],
          args = _componentProps$actio.slice(1);

      overrideProps[prop] = actionMapper[action].apply(actionMapper, (0, _toConsumableArray2["default"])(args));
    }); // Merge componentProps resolve props and actions resolve props

    if (componentProps.resolveProps && overrideProps.resolveProps) {
      mergedResolveProps = function mergedResolveProps() {
        var _componentProps;

        return _objectSpread(_objectSpread({}, (_componentProps = componentProps).resolveProps.apply(_componentProps, arguments)), overrideProps.resolveProps.apply(overrideProps, arguments));
      };
    } // do not pass actions object to components


    delete componentProps.actions;
  }

  return /*#__PURE__*/_react["default"].createElement(FormConditionWrapper, {
    condition: condition,
    field: componentProps
  }, /*#__PURE__*/_react["default"].createElement(FormFieldHideWrapper, {
    hideField: hideField
  }, /*#__PURE__*/_react["default"].createElement(Component, (0, _extends2["default"])({}, componentProps, overrideProps, mergedResolveProps && {
    resolveProps: mergedResolveProps
  }))));
};

SingleField.propTypes = {
  component: _propTypes["default"].string.isRequired,
  condition: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].array]),
  hideField: _propTypes["default"].bool,
  dataType: _propTypes["default"].string,
  validate: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].object])),
  initialValue: _propTypes["default"].any,
  actions: _propTypes["default"].shape((0, _defineProperty2["default"])({}, _propTypes["default"].string, _propTypes["default"].func)),
  resolveProps: _propTypes["default"].func
};

var renderForm = function renderForm(fields) {
  return fields.map(function (field) {
    return Array.isArray(field) ? renderForm(field) : /*#__PURE__*/_react["default"].createElement(SingleField, (0, _extends2["default"])({
      key: field.name
    }, field));
  });
};

var _default = renderForm;
exports["default"] = _default;